{$M, 8192,0,0}
USES GMemory, BoyerMo2, FileIO;

CONST
  BufferSize  = 65000;
  PatternSize = 30;
  MaxSearch   = 15;
  MaxFiles    = 5;


TYPE
  PArray = ^TArray;
  TArray = ARRAY[1..BufferSize] OF Byte;

  TByteData  = RECORD
      Search : STRING[PatternSize];
     Replace : STRING[PatternSize];
  END;

  TSearchData= RECORD
    FileName : STRING[12];
       Total : Byte;
        Data : ARRAY[1..MaxSearch] OF TByteData;
  END;

  TCrackData = RECORD
        Logo : ARRAY[1..4000] OF Byte;
      YCoord : Byte;
       Files : Byte;
        Data : ARRAY[1..5] OF TSearchData;
  END;

{$I EC\EC50\EC5_DATA.PAS}

VAR
  InFile       : Word;
  Index        : Word;
  Readen       : Word;
  FindCount    : Word;
  TotCracks    : Byte;

  Buffer       : PArray;
  SearchText   : STRING;
  ReplaceText  : STRING;
  SearchLength : Byte;
  ShiftTable   : ARRAY[Char] OF Byte;
  ScanBegin    : Word;

  Offset       : LongInt;
  BufferNum    : LongInt;
  InFileSize   : LongInt;
  InFilePos    : LongInt;

  CurrentFile  : Byte;


PROCEDURE _Write(Str:STRING); ASSEMBLER;
ASM
   LES   SI, Str
   XOR   CX, CX
   MOV   CL, ES:[SI]
   INC   SI
 @Loop:
   MOV   AH, 2
   SEGES LODSB
   MOV   DL, AL
   INT   21h
   LOOP  @Loop
END;


PROCEDURE Msg(St:STRING; Quit:Boolean);
BEGIN
  _Write(St+#13#10);
  IF Quit THEN
  BEGIN
    dAlloc(Buffer);
    Halt;
  END;
END;


PROCEDURE ReplaceBytes(Offset:LongInt);
VAR OldFilePos:LongInt; Written:Word; REP_Length:Byte;
BEGIN
  REP_Length := Length(ReplaceText);
  OldFilePos := fPOS(InFile);
  fSEEK(InFile, Offset);
  fWRITE(InFile,ReplaceText[1],REP_Length,Written);
  IF Written <> REP_Length THEN Msg('ERROR: Can''t write in '+CrackData.Data[CurrentFile].FileName,True);
  fSEEK(InFile, OldFilePos);
END;



{---------------------------------------------------------------------------}
PROCEDURE ShowLogo(VAR InBuf); ASSEMBLER;
ASM
  { Change mode }
  MOV AX, 0003h
  INT 10h
  { Move cursor }
  MOV AH, 0Fh
  INT 10h
  MOV AH, 02h
  XOR DL, DL
  MOV DH, CrackData.YCoord
  DEC DH
  INT 10h
  { Show logo }
  PUSH DS
  MOV DX, 0B800h
  LDS SI, InBuf
  MOV ES, DX
  XOR DI, DI
  MOV CX, 2000
 @L1:
  LODSB
  STOSB
  INC DI
  LOOP @L1
  LDS  SI, InBuf
  MOV  ES, DX
  XOR  DI, DI
  ADD  SI, 2000
  MOV  CX, 2000
 @L2:
  INC  DI
  LODSB
  STOSB
  LOOP @L2
  POP  DS
END;


FUNCTION IsLast:Boolean;
BEGIN
  IsLast := CurrentFile = CrackData.Files;
END;


{***************************************************************************}
{******************************* MAIN PROGRAM ******************************}
{***************************************************************************}
BEGIN
  ShowLogo(CrackData.Logo);

  IF CrackData.Files = 0 THEN Halt;{Msg('ERROR: Data not initialized');}

  Offset    := 0;
  BufferNum := 0;
  FindCount := 0;

  (* Allocate search buffer *)
  mAlloc(Buffer, BufferSize);

  (* OpenFile *)
  FOR CurrentFile := 1 TO CrackData.Files DO
  BEGIN

    InFile := fOpen(CrackData.Data[CurrentFile].FileName,oReadWrite);
    IF fERROR <> 0 THEN
    BEGIN
      Msg('ERROR: Can''t open '+CrackData.Data[CurrentFile].FileName,IsLast);
      Continue;
    END;

    (* Search *)
    REPEAT
      fRead(InFile,Buffer^,SizeOf(Buffer^),Readen);
      IF fError <> 0 THEN Msg('ERROR: Can''t read from '+CrackData.Data[CurrentFile].FileName,True);
      IF Readen = 0 THEN Break;

      FOR TotCracks := 1 TO CrackData.Data[CurrentFile].Total DO
      BEGIN
        SearchText  := CrackData.Data[CurrentFile].Data[TotCracks].Search;
        ReplaceText := CrackData.Data[CurrentFile].Data[TotCracks].Replace;

{      for index := 1 to length(searchtext)
        do write(dectohex(ord(searchtext[index])));
      writeln;}

        Make_Boyer_Moore_Table(SearchText, ShiftTable);
        ScanBegin := 1;
        SearchLength := Length(SearchText);
        REPEAT
          Index := Boyer_Moore_Search(Buffer^,ScanBegin,Readen,SearchText,ShiftTable);
          IF Index > 0 THEN
          BEGIN
            Offset := Pred(Index) + (BufferNum*SizeOf(Buffer^));
            ReplaceBytes(Offset);

{          _Write('$'+DecToHex(Offset)+#13#10);}

            ScanBegin := Index+1;
            Inc(FindCount);
          END
        UNTIL Index = 0;
      END; {FOR}
      Inc(BufferNum);
    UNTIL Readen = 0;
    fClose(InFile);
    IF FindCount = 0
      THEN Msg('ERROR: Corect bytes not found in '+CrackData.Data[CurrentFile].FileName,IsLast)
      ELSE Msg(CrackData.Data[CurrentFile].FileName+' is CRACKED!',IsLast);
    Offset    := 0;
    BufferNum := 0;
    FindCount := 0;
  END;
END.